/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.stanford.facs.cytometers;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.MeehanMetaSpace.Basics;

import edu.stanford.facs.cytometers.beans.BandPassFilter;
import edu.stanford.facs.cytometers.beans.FACS;
import edu.stanford.facs.cytometers.beans.FACSConfiguration;
import edu.stanford.facs.cytometers.beans.LaserConfiguration;
import edu.stanford.facs.cytometers.beans.LongPassFilter;
import edu.stanford.facs.cytometers.beans.OpticalDetector;
import edu.stanford.facs.cytometers.beans.OpticalFilter;


public class InstrumentDownload  {

    private static String SW="Software Version";
    private static String CYTOMETER ="Cytometer";
    private static String CONFIG_NAME = "Configuration Name";
    private static String LASER_NAME = "Laser Name";
    private static String DIVA_TEMPLATE_FILE = "DivaTemplateFile";
    private static String LOCAL_HOST = "LocalHost";
    private static String LOCAL_NAME = "LocalName";
    private static String SITE_NAME = "SiteName";
    private static String MANUFACTURER = "Manufacturer";
    private static String LOCATION = "Location";
    private static String MAX_COLORS = "MaxColors";
    private static String MAX_LASERS = "MaxLasers";

    // I IS FOR INDEX INTO THE ARRAY OF STRING VALUES;
    protected static int ISW = 0;
    protected static int ICYTOMETER = 1;
    protected static int ICONFIG_NAME = 2;
    protected static int ILASER_NAME = 3;
    protected static int IDIVA_FILE = 4;
    protected static int ILOCAL_HOST = 5;
    protected static int ILOCAL_NAME = 6;
    protected static int ISITE_NAME = 7;
    protected static int IMAX_COLORS=8;
    protected static int IMANUFACTURER=9;
    protected static int ILOCATION=10;
    protected static int IMAX_LASERS=11;
    public static String DETECTORS = "DETECTORS";
    public static String VALUES = "VALUES";
    public static String LASERS = "LASERS";
    private StringBuffer errorMsg = new StringBuffer();


    private static int LASER = 0;
    private static int TYPE = 1;
    private static int WAVELENGTH = 2;
    private static int POWER = 3;
    //private static int D_ARRAY = 4;
    private static int DETECTOR = 5;
    private static int CHANNEL = 6;
    //private static int MIRROR  = 7;
    private static int FILTER = 8;
    private static int PARAMETER = 9;

    private String waveLengthValue = null;
 

    	public InstrumentDownload() {
    	}

    	public static void main(String []args) {
    		InstrumentDownload download = new InstrumentDownload();
    		try {
				String a[] = download.getInstrumentList();
				for (String inst: a) {
					String s = "./configurations/"+inst;
					URL resource = InstrumentDownload.class.getResource(s);//"./configurations/index.txt"
					if (resource == null) {
			            throw new IllegalArgumentException("file is not found!");
			        } else {
			        	HashMap<String,Object[]> map = download.readConfigFile(new File(resource.getFile()));
			        	System.out.println("Got");
			        }
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    	
    	
    	public static List<FACSConfiguration> getAllFacs() {
    		List<FACSConfiguration> list=new ArrayList<FACSConfiguration>();
    		
    		try {
    			InstrumentDownload download = new InstrumentDownload();
    			String a[] = download.getInstrumentList();
    			for (String inst: a) {
    				String s = "./configurations/"+inst;
    				URL resource = InstrumentDownload.class.getResource(s);
    				if (resource == null) {
    		            throw new IllegalArgumentException("file is not found!");
    		        } else {
    		        	HashMap<String,Object[]> map = download.readConfigFile(new File(resource.getFile()));
    		        		/*protected static int ISW = 0;
    		        	    protected static int ICYTOMETER = 1;
    		        	    protected static int ICONFIG_NAME = 2;
    		        	    protected static int ILASER_NAME = 3;
    		        	    protected static int IDIVA_FILE = 4;
    		        	    protected static int ILOCAL_HOST = 5;
    		        	    protected static int ILOCAL_NAME = 6;
    		        	    protected static int ISITE_NAME = 7;
    		        	    protected static int IMAX_COLORS=8;
    		        	    protected static int IMANUFACTURER=9;
    		        	    protected static int ILOCATION=10;
    		        	    protected static int IMAX_LASERS=11;*/
    		        	    
    		        	    Integer maxLasers;
    		        		String comments;
    		        		String key;
    		        		Integer maxOpticalDetectors;
    		        		String model;
    		        		Integer maxForwardScatter;
    		        		Boolean sorter;
    		        		Boolean Isconfigurable;
    		        		Integer maxSideScatter;
    		        	    
    		        	String descriptors[]= (String[])map.get(InstrumentDownload.VALUES);
    		        	FACSConfiguration facsConfig = new FACSConfiguration();
    		        	FACS facs= new FACS();
    		        	
    		        	facs.setMaxLasers(Integer.parseInt(descriptors[11]));
    		        	facs.setKey(descriptors[1]);
    		        	facsConfig.setFacs(facs);
    		        	facsConfig.setKey(descriptors[2]);
    		            
    		        	
    		        	LaserConfiguration[] lasers = (LaserConfiguration[])map.get(InstrumentDownload.LASERS);
    		        	OpticalDetector[] detectors = (OpticalDetector[])map.get(InstrumentDownload.DETECTORS);
    		        	facsConfig.setLaserConfiguration(lasers);
    		        	facsConfig.setFacsTOOpticalDetector(detectors);
    		        	list.add(facsConfig);
    		        }

    				
    			}
    		} catch (IOException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
    		return list;
    	}
    	
    	public static HashMap<String, FACSConfiguration> getAllFacsByName() {
    		HashMap<String, FACSConfiguration> instrumentsByKey = new HashMap<String, FACSConfiguration>();
    		
    		try {
    			InstrumentDownload download = new InstrumentDownload();
    			String a[] = download.getInstrumentList();
    			for (String inst: a) {
    				String s = "./configurations/"+inst;
    				URL resource = InstrumentDownload.class.getResource(s);
    				if (resource == null) {
    		            throw new IllegalArgumentException("file is not found!");
    		        } else {
    		        	HashMap<String,Object[]> map = download.readConfigFile(new File(resource.getFile()));
    		        		/*protected static int ISW = 0;
    		        	    protected static int ICYTOMETER = 1;
    		        	    protected static int ICONFIG_NAME = 2;
    		        	    protected static int ILASER_NAME = 3;
    		        	    protected static int IDIVA_FILE = 4;
    		        	    protected static int ILOCAL_HOST = 5;
    		        	    protected static int ILOCAL_NAME = 6;
    		        	    protected static int ISITE_NAME = 7;
    		        	    protected static int IMAX_COLORS=8;
    		        	    protected static int IMANUFACTURER=9;
    		        	    protected static int ILOCATION=10;
    		        	    protected static int IMAX_LASERS=11;*/
    		        	    Integer maxLasers;
    		        		String comments;
    		        		String key;
    		        		Integer maxOpticalDetectors;
    		        		String model;
    		        		Integer maxForwardScatter;
    		        		Boolean sorter;
    		        		Boolean Isconfigurable;
    		        		LaserConfiguration[] possibleLaserConfigurationsValues;
    		        		Integer maxSideScatter;
    		        	   
    		        	String descriptors[]= (String[])map.get(InstrumentDownload.VALUES);
    		        	 
    		        	FACSConfiguration facsConfig = new FACSConfiguration();
    		        	FACS facs= new FACS();
    		        	
    		        	if (descriptors[11] != null) {
    		        		facs.setMaxLasers(Integer.parseInt(descriptors[11]));
    		        	}
    		        	facs.setKey(descriptors[1]);
    		        	facsConfig.setFacs(facs);
    		        	facsConfig.setKey(descriptors[2]);
    		        	facsConfig.setName(descriptors[6]);
    		            
    		        	
    		        	LaserConfiguration[] lasers = (LaserConfiguration[])map.get(InstrumentDownload.LASERS);
    		        	OpticalDetector[] detectors = (OpticalDetector[])map.get(InstrumentDownload.DETECTORS);
    		        	facsConfig.setLaserConfiguration(lasers);
    		        	facsConfig.setFacsTOOpticalDetector(detectors);
    		        	instrumentsByKey.put(descriptors[2], facsConfig);
    		        }
    			}
    		} catch (IOException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
    		return instrumentsByKey;
    	}
    	
    	
        public String getErrorMessage() {
            return errorMsg.toString();
        }
        /*
         * Open the index file and get the list of instruments that are ready 
         * for import.  These are the ones that end in _2.csv.  
         * */
        public String[]  getInstrumentList() 
                throws IOException {
            ArrayList<String> list = new ArrayList<String>();
            BufferedReader reader = new BufferedReader(new InputStreamReader((InstrumentDownload.class.getResourceAsStream("./configurations/index.txt"))));
            String line = reader.readLine();
            while (line != null){
                if (line.endsWith ("_2.csv")){
                   list.add (line);    
                }
                line = reader.readLine();
            }
            String[] sarray = new String[list.size()];
            sarray = (String[]) list.toArray(sarray);
            return sarray;
            
        }
  
   
    /*
     *  This reads the csv file and gets the information needed to make
     * an instrument.  It returns a HashMap of Arrays.  One array contains
     * the public strings above, like the name of the cytometer model, the
     * Default diva file, the host name, the site name.  The other array is an
     * array of Detectors.
     */

    public HashMap<String,Object[]> readConfigFile ( File configFile){


        boolean flag = false;
        String[] tokens;
        String linesep = System.getProperty ("line.separator");



        HashMap<String,Object[]> hashMap = new HashMap <String, Object[]>();
        String[] descriptors = new String[12];

        ArrayList<OpticalDetector> detectors = new ArrayList<OpticalDetector>();
        ArrayList<LaserConfiguration> lasers = new ArrayList<LaserConfiguration>();

        LaserConfiguration curLaser = null;
        OpticalDetector newDetector = null;
        int ncolors = 0;
        int EOF = -1;

//System.out.println ("InstrumentDownload.readConfigFile ");
        try {
           // File file = new File (docDir + File.separator+configFilename);
            FileReader reader = new FileReader (configFile);
            BufferedReader buf = new BufferedReader (reader);
            String line = buf.readLine();
            while (line != null && !flag  ){
//        System.out.println (line);
                tokens = line.split(",");
                    if (tokens[0].matches (SW)){
                        descriptors[ISW]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches(CYTOMETER)){
                        descriptors[ICYTOMETER]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches (CONFIG_NAME)){
                    	if (tokens.length > 1 && !Basics.isEmpty(tokens[1])) {
                    		descriptors[ICONFIG_NAME]= new String (tokens[1]);
                    	}
                    }
                    else if (tokens[0].matches (DIVA_TEMPLATE_FILE)){
                    	if (tokens.length > 1 && !Basics.isEmpty(tokens[1])) {
                    		descriptors[IDIVA_FILE]= "";//new String (docDir+File.separator+tokens[1]);                    		
                    	}
                    }
                    else if (tokens[0].matches (LOCAL_NAME)){
                        descriptors[ILOCAL_NAME]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches (LOCAL_HOST)){
                    	if (tokens.length > 1 && !Basics.isEmpty(tokens[1])) {
                    		descriptors[ILOCAL_HOST]= new String (tokens[1]);
                    	}
                    }
                    else if (tokens[0].matches (SITE_NAME)){
                        descriptors[ISITE_NAME]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches (MANUFACTURER)){
                        descriptors[IMANUFACTURER]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches (LOCATION)){
                    	if (tokens.length > 1 && !Basics.isEmpty(tokens[1])) {
                    		descriptors[ILOCATION]= new String (tokens[1]);                    		
                    	}
                    }
                    else if (tokens[0].matches (MAX_COLORS)){
                        descriptors[IMAX_COLORS]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches (MAX_LASERS)){
                        descriptors[IMAX_LASERS]= new String (tokens[1]);
                    }
                    else if (tokens[0].matches(LASER_NAME)){
                        flag = true;
                    }
                    //the blank line problem
                    char[]cbuf =new char[1];
                    int ii = buf.read(cbuf);
//                    System.out.println (" how many characters were read? "+ ii);
                    if ( ii == EOF){
                        flag = false;
//                        System.out.println ("End of file reached");
                    }
                    else {
//                        System.out.println (" what is the value of ii? ["+cbuf[0] +"]" );
                        if (linesep.equals (new String (cbuf))){
                    line = buf.readLine();
//                            System.out.println ("if (1) "+ line);
                        }
                        else {
                            line = new String (cbuf) +buf.readLine();
//                            System.out.println (" else (1) "+ line);
                        }

                    }
//          System.out.println (" -------> what is the line in the top part "+ line);

            }
            // whatever happened in the header part of the file, we are done
            // with that.  The current line is the Laser name line.
//            System.out.println ("what is the line now? " + line);
            errorMsg.append ( "\nThe header part is good. ");
            while (flag  ){
                if (line != null && !line.equals("")) {  //otherwise it is a blank line.
                    String[] oneline = line.split(",");
//                    System.out.println ( "["+line + "]  --length of oneline -- " + oneline.length);
          
                /*
                 * each line is a detector unless DETECTOR is empty.  DETECTOR is empty when there
                 * are multiple parameter names for this detector.  Each detector gets a new
                 * object.  But the filters and lasers should be searched out from the matching
                 * objects.  So first determine if this is a detector row ([DETECTOR] != null.
                 * Then determine if this is a new laser row ([LASER] != null.  If it is a new
                 * laser row, try to find a laser that matches.  Each detector has a filter.
                 * Try to find filters that match.  have to parse those guys for wavelength
                 * center and wavelength range.
                 * There are detectors that are not set-up and have no channel, mirror, filter,
                 * or parameter, at least in this UPenn test file.
                 * */
/*
 * FacsToOpticalDetector
 * InstallationTOConfoguration
 * */	
                    setWaveLengthValue(oneline);
                    if(!isSideScatterChannel(oneline)){
                    if (DETECTOR < oneline.length  && oneline[DETECTOR] !=null && !oneline[DETECTOR].equals("")){  //detector
                        ncolors++;

                        if (enoughInfo(oneline) ) {
                            OpticalFilter filter= null;
//                            System.out.println ("New detector --"+ oneline[DETECTOR]);
                            newDetector = new OpticalDetector();
                            filter = getFilterModel (oneline[FILTER]);
//                            System.out.println ("filter is " + filter.getKey() + ", "+ filter.getWavelengthCenter());


                            //a new laser
                            if (oneline[LASER] != null && !oneline[LASER].equals("")){
//                                System.out.println ("Is the problem here ?  " + oneline[LASER]);
                                if (curLaser != null)
                                    lasers.add (curLaser);
                                curLaser = getLaserModel (oneline);
//                                System.out.println (" Returning from the getLaserModel " + curLaser.getKey());
                            }
                            else {
//                                System.out.println ("Missing laser information ");
                                errorMsg.append (" Missing laser information for the detector "+ oneline[DETECTOR]);
                            }
//                            System.out.println ("what's in the laser? ("+ oneline[LASER]+")");
                            newDetector.setLaserKey (curLaser.getKey());
                            newDetector.setFcsParameterNumber (new Integer(oneline[CHANNEL]));
                            //for some reason, this names is being added with quotes around it.
                            String name = oneline[PARAMETER];
                            if (name.contains("\"")) {
                                name = Basics.strip (name, "\"");
                            }

//                 System.out.println ("\t\t -------- Adding an alternative parameter name  " + oneline[PARAMETER] + "   "+ name);
                            newDetector.addAlternativeParameterNames (name);
                            if (newDetector.getAlternativeParameterNames().length == 1)
                                newDetector.setKey (name);
                            else 
                            	newDetector.setKey (curLaser.getKey());
                            newDetector.setOpticalDetectorTOLaser (curLaser);
                            newDetector.setOpticalDetectorTOBandPass(filter);
                            newDetector.setOpticalFilterKey (filter.getKey());

                            detectors.add (newDetector);
                        }
                        else {
                            errorMsg.append ("New Detector did not have enough information to be created.\n");
                            errorMsg.append ("Detector="+ oneline[DETECTOR]);
//                            System.out.println (" not enough information or caught the SSC");
                        }
                    }
                
                    else {
                    	if (oneline[LASER] != null && !oneline[LASER].equals("")){
                    		if (curLaser != null)
                                lasers.add (curLaser);
                            curLaser = getLaserModel (oneline);
                         }
                        //a new parameter
//                        System.out.println ("In the else clause -- length of one line is " + oneline.length);
                        if (PARAMETER < oneline.length  ) {
                            if (oneline[PARAMETER] != null) {
                                String p = oneline[PARAMETER].toUpperCase();
                                if (!p.startsWith("SSC") && !p.startsWith ("FSC")){
                                    String name = oneline[PARAMETER];
                                    if (name.contains("\"")) {
                                        name = Basics.strip (name, "\"");
                                    }
                                    //when importing, we will use the first parameter name as the Key.
                                    //When exporting, the parameter name used as the key will be
                                    //listed first.
//             System.out.println ("\t\t -------- Adding an alternative parameter name  " + oneline[PARAMETER] + "   "+ name);
                                    
                                    newDetector.addAlternativeParameterNames (name);
                                    if (newDetector.getAlternativeParameterNames().length == 1)
                                        newDetector.setKey(name) ;
                                }

                            }
                        }
                    }
                    }else{
                    	 if (oneline[LASER] != null && !oneline[LASER].equals("")){
                    		 curLaser =  getLaserModel (oneline);
                    	 }
                    }
                    //do a look-ahead because of the possibilities of blank lines.
                    char[]cbuf =new char[1];
                    int ii = buf.read(cbuf);
//                    System.out.println (" how many characters were read? "+ ii);
                    if ( ii == EOF){
                        flag = false;
//                        System.out.println ("End of file reached");
                    }
                    else {
//                        System.out.println (" what is the value of ii? ["+cbuf[0] +"]" );
                        if (linesep.equals (new String (cbuf)))
                            line = buf.readLine();
                        else {
                            line = new String (cbuf) +buf.readLine();
                        }

                    }

                    
                } //done reading the file.
               
              
            }
            buf.close();
            if(curLaser != null)
            	lasers.add (curLaser);
            //descriptors[IMAX_COLORS] = new Integer (ncolors).toString();
            OpticalDetector[]detectorArray = new OpticalDetector[detectors.size()];
            detectorArray = detectors.toArray (detectorArray);
            LaserConfiguration[] laserArray = new LaserConfiguration[lasers.size()];
            laserArray = lasers.toArray (laserArray);
            hashMap.put (DETECTORS, detectorArray);
            hashMap.put (VALUES, descriptors);
            hashMap.put (LASERS, laserArray);

        }  catch (Exception e){
            System.out.println (e.getMessage());
            errorMsg.append (" Unable to create the instrument due to errors in the file.\n  ");
            
//            e.printStackTrace();
        }
        return hashMap;

    }
    public void setWaveLengthValue(String[] line) {
    	if(!Basics.isEmpty(line) && line.length > WAVELENGTH && !Basics.isEmpty(line[WAVELENGTH])){
    		waveLengthValue = line[WAVELENGTH];
    	}
	}
    
    public String getWaveLengthValue(){
    	return waveLengthValue;
    }

	private boolean isSideScatterChannel(String[] oneline) {
    	boolean ssc = false;
		if(!Basics.isEmpty(oneline) && oneline.length > FILTER && !Basics.isEmpty(oneline[FILTER]) && !Basics.isEmpty(getWaveLengthValue())){
			final OpticalFilter filter= getFilterModel (oneline[FILTER]);
			final int filterWaveLength = filter.getWavelengthCenter();
			if(filterWaveLength <= Integer.parseInt(getWaveLengthValue())){
				ssc = true;
			}
		}
		return ssc;
	}

	/* sometimes there are blank lines in the line or detectors that are not assigned
     * */
    private boolean enoughInfo (String[]line){
        boolean flag = true;
        if (line.length <=CHANNEL || (line.length > CHANNEL && Basics.isEmpty(line[CHANNEL])))
            flag= false;
        else if (line.length >= PARAMETER ){
            //check for forward and side scatter channels
            String para = line[PARAMETER].toUpperCase();
            if (para.startsWith ("SSC") || para.startsWith ("FSC"))
                flag = false;
        }

        return flag;
    }
    
    /* either this matches a laser that is already defined or I will create
     * a new laser.
     * */
    private LaserConfiguration getLaserModel (String[] line){
        LaserConfiguration laser = null;


        LaserConfiguration[] all = LaserConfiguration.getAll();
        for (final LaserConfiguration one : all){
            if (one != null && one.getKey() != null && one.getWavelength() != null){
            if (one.getKey().equals (line[LASER])){
                Integer power = one.getPower();
                Integer wavelength = one.getWavelength();
                    int newwave=0;
                    try {
                        Integer inewwave = new Integer (line[WAVELENGTH]);
                        newwave = inewwave.intValue();
                    } catch (NumberFormatException we){
//                        System.out.println ("(1) Number format exception .  new wavelength set to 0");

                    }
                    int newpower=0;
                    try {
                        Integer inewpower = new Integer (line[POWER]);
                        newpower = inewpower.intValue();
                    } catch (Exception pe){
//                        System.out.println ("(2) Number format expection.  newpower is set to 0");
                    }

//                    System.out.println ("(3)getLaserModel " + one.getKey() + ", "+ newpower + ", "+ wavelength + " "+ newwave );
                    if (wavelength.intValue() == newwave) {
//                        System.out.println ("(3a) wavelength is the same ");
                    	laser = one;
                    	  //Avoiding power comparison to avoid duplicates
                        /*if (power == null){
//                            System.out.println ("(3b) power is null");
                            one.setPower(0);
                            power = one.getPower();
//                            System.out.println ("(3c reset the power to 0 ");
                        }
                        if (power.intValue() == newpower){
                        laser = one;
//                            System.out.println ("(4) Laser Model matches ");
                        break;
                    } */

                }
            }
            }
        }
        if (laser == null){ // it is a new laser configuration

//            System.out.println ("(5) A new laser configuration?  " + line[LASER] + " "+ line[POWER]+ " "+ line[WAVELENGTH]);
            laser = new LaserConfiguration();
            laser.setKey (line[LASER]);
//            System.out.println ("New laser key --" + laser.getKey());
            try {
            laser.setPower (new Integer (line[POWER]));
            } catch (NumberFormatException e1){
//                System.out.println (" (6) No power will be set for laser " + line[LASER]);
                laser.setPower (0);
            }
            try {
            laser.setWavelength (new Integer (line[WAVELENGTH]));
            } catch (NumberFormatException e){
//               System.out.println ("(7) No wavelength will be set for laser "+ line[LASER]);
               laser.setWavelength (0);

            }

        }
        return laser;
    }


    /*
     * Filters are equals when the wavelength center and wavelength
     * range are the same.  Except in the csv file the filter looks
     * like 780/60 BP or 670 LP or 610/20 BP
     * */
    private OpticalFilter getFilterModel (String filter) throws NullPointerException {

        OpticalFilter opfilter = null;
        int center = 0;
        int range = 0;
        String scenter=null, srange=null;
        //Basics.isValidWholeNumber (String )
        if (filter.contains ("BP")){
           
            //its a band pass  wavelength center /range 610/40 BP
            int slash = filter.indexOf("/");
            if (slash > -1){
                scenter = filter.substring (0, slash).trim();
                int b = filter.indexOf("B");
                if (b > -1)
                    srange = filter.substring (slash+1, b).trim();
                if (Basics.isValidWholeNumber (scenter) && Basics.isValidWholeNumber (srange)){
                    center = new Integer (scenter).intValue();
                    range = new Integer (srange).intValue();
                    
                }
                else {
//                    System.out.println (" ERROR in center and range ");
                    return null;

                }
            }
            BandPassFilter bpfilters[] = BandPassFilter.getAll();
            for (BandPassFilter f: bpfilters){
                try {

                    Integer ii = f.getWavelengthCenter();
                    int ctr=0, rng=0;
                    if (ii != null)
                        ctr = ii.intValue();
                    ii = f.getWavelengthRange();
                    if (ii != null)
                        rng = ii.intValue();
                    
                    if (ctr == center && range == rng){
                        opfilter = f;
                        break;
                    }
                } catch (Exception e){
//                    System.out.println ("exception in the filters " + e.getMessage());
                    e.printStackTrace();
                }

            }
            if (opfilter == null){
                BandPassFilter bp = new BandPassFilter();
                bp.setWavelengthRange (range);
                bp.setWavelengthCenter(center);
                bp.setKey (filter);
                return bp;

            }

        }
        else { //long pass filter
            int s = filter.indexOf ("L");
//            System.out.println (" Long pass filter index of L " + s);
            if (s > -1){
                scenter = filter.substring(0,s-1).trim(); 
                if (Basics.isValidWholeNumber (scenter)){
                   center = new Integer (scenter).intValue();
                }

                else {
//                    System.out.println (" Error in the long pass filter part");
                    return null;
                }
            }
            LongPassFilter lpfilters[]= LongPassFilter.getAll();
            for (LongPassFilter lp: lpfilters){
                if (lp == null || lp.getWavelengthCenter() == null
                               || lp.getKey() == null ){
//                    System.out.println ("lp the longPassFilter is null ");
                }
                else {
//                    System.out.println ("LongPassFilter " + lp.getWavelengthCenter() + " "+ lp.getKey());
                    int ctr = lp.getWavelengthCenter().intValue();
                    if (ctr == center){
                        opfilter = lp;
                        break;
                    }
                }
            }
            if (opfilter == null){
                LongPassFilter lpf = new LongPassFilter();
                lpf.setKey (filter);
                lpf.setWavelengthCenter(center);
                return lpf;
            }
        }
        return opfilter;

    }

        
}

       

